#include "demowidgets.h"
#include "./ui_demowidgets.h"

using namespace std;

DemoWidgets::DemoWidgets(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::DemoWidgets)
{
    ui->setupUi(this);

    initializeMenu();
    initializeTable();
}

DemoWidgets::~DemoWidgets()
{
    delete ui;
}

enum { COLOR_ROW, DEPT_ROW, FOOD_ROW };
enum { LABEL_COL, DATA_COL };
enum { AMERICAN_FOOD, CHINESE_FOOD, INDIAN_FOOD };

const QString FOODS[] = { "American", "Chinese", "Indian" };

void DemoWidgets::initializeTable()
{
    ui->dataTable->setItem(COLOR_ROW, LABEL_COL, new QTableWidgetItem(QString("Color")));
    ui->dataTable->setItem(DEPT_ROW,  LABEL_COL, new QTableWidgetItem(QString("Department")));
    ui->dataTable->setItem(FOOD_ROW,  LABEL_COL, new QTableWidgetItem(QString("Food")));

    QStringList headers;
    headers << "Item" << "Choice";

    ui->dataTable->setColumnCount(2);
    ui->dataTable->setHorizontalHeaderLabels(headers);
}

void DemoWidgets::initializeMenu()
{
    ui->foodMenu->addItem(FOODS[AMERICAN_FOOD], AMERICAN_FOOD);
    ui->foodMenu->addItem(FOODS[CHINESE_FOOD],  CHINESE_FOOD);
    ui->foodMenu->addItem(FOODS[INDIAN_FOOD],   INDIAN_FOOD);
}

void DemoWidgets::on_submitButton_clicked()
{
    QString name = ui->nameBox->toPlainText();
    ui->greetingMessage->setText("Hi, " + name + "!");
}

void DemoWidgets::on_redCB_stateChanged(int arg1)
{
    showColorChoices();
}

void DemoWidgets::on_greenCB_stateChanged(int arg1)
{
    showColorChoices();
}

void DemoWidgets::on_blueCB_stateChanged(int arg1)
{
    showColorChoices();
}

void DemoWidgets::showColorChoices()
{
    char buffer[16];
    string colors = "";

    if (ui->redCB->isChecked())   colors += "red ";
    if (ui->greenCB->isChecked()) colors += "green ";
    if (ui->blueCB->isChecked())  colors += "blue";
    strcpy(buffer, colors.c_str());

    ui->dataTable->setItem(COLOR_ROW, DATA_COL, new QTableWidgetItem(QString(buffer)));
}

void DemoWidgets::on_adsRB_clicked()
{
    ui->dataTable->setItem(DEPT_ROW, DATA_COL, new QTableWidgetItem(QString("Applied Data Science")));
}

void DemoWidgets::on_csRB_clicked()
{
    ui->dataTable->setItem(DEPT_ROW, DATA_COL, new QTableWidgetItem(QString("Computer Science")));
}

void DemoWidgets::on_cmpeRB_clicked()
{
    ui->dataTable->setItem(DEPT_ROW, DATA_COL, new QTableWidgetItem(QString("Computer Engineering")));
}

void DemoWidgets::on_foodMenu_currentIndexChanged(int index)
{
    ui->dataTable->setItem(FOOD_ROW, DATA_COL, new QTableWidgetItem(FOODS[index]));
}
